<?php
//
// Description: This file deals with commands accepted by ssh
//
require_once($INC . "/sql.inc.php");
require_once($INC . "/state.inc.php");
require_once($INC . "/prof.inc.php");
require_once($INC . "/repo.inc.php");

function rg_ssh_status($db, $uid)
{
	rg_log("ssh_status");

	echo "Here will be the status.\n";

	// also details about payments: warn if disk space is low etc.

	exit(0);
}

function rg_ssh_repos($db, $uid)
{
	rg_log("ssh_repos");

	echo "\n";
	echo "Repositories (name, creation, disk used/quota):\n";
	$sql = "SELECT * FROM repos"
		. " WHERE uid = $uid"
		. " AND deleted = 0"
		. " ORDER BY name, itime";
	$pad = "                                              ";
	$res = rg_sql_query($db, $sql);
	while (($row = rg_sql_fetch_array($res))) {
		echo substr(substr($row['name'], 0, 40) . $pad, 0, 32)
			. "\t" . gmdate("Y-m-d", $row['itime'])
			. "\t" . rg_1024($row['disk_used_mb']) . "/" . rg_1024($row['disk_quota_mb'])
			. "\n";
	}
	rg_sql_free_result($res);

	echo "\n";
	exit(0);
}

function rg_ssh_repo($db, $uid, $paras)
{
	rg_log("ssh_repo: " . rg_array2string($paras));

	$repo_name = trim($paras[0]);

	$rr = array("uid" => $uid, "repo" => $repo_name);
	$ri = rg_repo_info($db, $rr);
	if ($ri === FALSE) {
		echo "Unknown repo!\n";
		exit(0);
	}

	echo "Repo:		" . $ri['name'] . "\n";
	echo "Creation time:	" . gmdate("Y-m-d", $ri['itime']) . " UTC\n";
	echo "Disk used:	" . rg_1024($ri['disk_used_mb']) . " MiB\n";
	echo "Disk quota:	" . rg_1024($ri['disk_quota_mb']) . " MiB\n";
	$rights = implode(", ", rg_rights_text("repo", $ri['default_rights']));
	echo "Default rights:	" . $rights . "\n";
	echo "Description:	" . $ri['description'] . "\n";

	if ($ri['master'] > 0) {
		$rr = array("repo_id" => $ri['master']);
		$mri = rg_repo_info($db, $rr);
		if ($mri !== FALSE) {
			echo "Master:		" . $mri['name'] . "\n";
		}
	}

	exit(0);
}

function rg_ssh_dispatch($db, $uid, $cmd)
{
	$paras = explode(" ", $cmd);
	$cmd = array_shift($paras);

	switch ($cmd) {
		case 'status': rg_ssh_status($db, $uid); break;
		case 'repos': rg_ssh_repos($db, $uid); break;
		case 'repo': rg_ssh_repo($db, $uid, $paras); break;
		case '':
			echo "\nWelcome to RocketGit!\n\n";
			echo "Available commmands: status, repos.\n";
			echo "\n";
			exit(0);
	}
}

?>
