Summary:	Light and fast Git hosting solution
Name:		rocketgit
Version:	0.13
Release:	1
License:	GPLv3
Group:		Development/Tools
Source:		http://kernel.embedromix.ro/us/rocketgit/%{name}-%{version}.tar.gz
URL:		http://kernel.embedromix.ro/us/
BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot
BuildArch:	noarch
Requires:	httpd, php, php-cli, php-pgsql, php-gd, xinetd
Requires:	shadow-utils, git, postgresql-server, policycoreutils-python


%description
Light and fast Git hosting solution, similar with Gitorious/GitHub/etc.

%pre
getent group rocketgit || groupadd -r rocketgit
getent passwd rocketgit || useradd -r -g rocketgit -s /bin/bash -m -d /home/rocketgit -c "RocketGit user" rocketgit
semanage fcontext -a -t httpd_log_t "/var/log/rocketgit-web(/.*)?" || :

%post
if [ $1 -ne 0 ]; then
	/sbin/service xinetd reload &>/dev/null || :
	/sbin/service httpd reload &>/dev/null || :
fi

%postun
if [ $1 = 0 ]; then
	userdel rocketgit
	semanage fcontext -d "/var/log/rocketgit-web(/.*)?" || :
fi

%prep
%setup -q

%build
%configure
make

%install
rm -rf ${RPM_BUILD_ROOT}
mkdir -p ${RPM_BUILD_ROOT}
make install DESTDIR=${RPM_BUILD_ROOT}

%clean
rm -rf ${RPM_BUILD_ROOT}

%files
%attr (-,root,root)
/usr/share/rocketgit
%doc README LICENSE Changelog TODO
%dir /etc/rocketgit
%config(noreplace) /etc/rocketgit/config.php
/etc/rocketgit/config.php.sample
/etc/cron.d/rocketgit
%config(noreplace) /etc/xinetd.d/rocketgit
%config(noreplace) /etc/httpd/conf.d/rocketgit.conf
%attr(0700,rocketgit,rocketgit) %dir /var/log/rocketgit
%attr(0700,apache,apache) %dir /var/log/rocketgit-web
%attr(0700,rocketgit,rocketgit) %dir /var/lib/rocketgit
%attr(0700,rocketgit,rocketgit) %dir /var/lib/rocketgit/locks
%attr(0700,rocketgit,rocketgit) %dir /var/lib/rocketgit/repos
%attr(0700,rocketgit,rocketgit) %dir /var/lib/rocketgit/q_merge_requests
%config(noreplace) /etc/logrotate.d/rocketgit

%changelog
* Wed Oct 17 2012 Catalin(ux) M. BOIE <catab at embedromix dor ro> 0.10
Alpha1 version released with a lot of fixes and some features.

* Mon Jun 27 2011 Catalin(ux) M. BOIE <catab at embedromix dot ro> 0.2
Another round of bulk changes.
