<?php
error_reporting(E_ALL | E_STRICT);
ini_set("track_errors", "On");

$INC = "../inc";
require_once($INC . "/init.inc.php");
require_once($INC . "/rights.inc.php");

rg_log_set_file("rights.log");

rg_log("test if combine works correctly (1)");
$a = "AF"; $b = "AD"; $e = "AFD";
$r = rg_rights_combine($a, $b);
if (strcmp($r, $e) != 0) {
	echo "Combine rights error1 ([$r] vs [$e])\n";
	exit(1);
}

rg_log("test if combine works correctly (2)");
$a = ""; $b = ""; $e = "";
$r = rg_rights_combine($a, $b);
if (strcmp($r, $e) != 0) {
	echo "Combine rights error1 ([$r] vs [$e])\n";
	exit(1);
}

rg_log("test if combine works correctly (3)");
$a = "AXUJUNFUUFU"; $b = ""; $e = $a;
$r = rg_rights_combine($a, $b);
if (strcmp($r, $e) != 0) {
	echo "Combine rights error1 ([$r] vs [$e])\n";
	exit(1);
}

rg_log("testing mask...");
$a = "ABCDE"; $mask = "AEZ"; $e = "AE";
$r = rg_rights_mask($a, $mask);
if (strcmp($e, $e) != 0) {
	echo "mask is not working right [$r] != [$e]!\n";
	exit(1);
}

rg_log("rights: testing allow...");
$rights = "ABC"; $needed_rights = "BCD";
$r = rg_rights_allow($rights, $needed_rights);
if ($r !== FALSE) {
	echo "allow is not working right!\n";
	exit(1);
}

rg_log("rights: testing allow...");
$rights = "ABC"; $needed_rights = "";
$r = rg_rights_allow($rights, $needed_rights);
if ($r !== TRUE) {
	echo "allow is not working right (empty needed_rights)!\n";
	exit(1);
}

echo "rights: OK!\n";
?>
